DEFINE VARIABLE d1  AS DATE     NO-UNDO.
DEFINE VARIABLE d2  AS DATE     NO-UNDO.
DEFINE VARIABLE d3  AS DATE     NO-UNDO.
DEFINE VARIABLE d4  AS DATE     NO-UNDO.
DEFINE VARIABLE d5  AS DATE     NO-UNDO.
DEFINE VARIABLE d6  AS DATE     NO-UNDO.
DEFINE VARIABLE d7  AS DATE     NO-UNDO.
DEFINE VARIABLE dt1 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt2 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt3 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt4 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt5 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt6 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt7 AS DATETIME NO-UNDO.

DISPLAY "SESSION:TIME-SOURCE = " SESSION:TIME-SOURCE SKIP.
SESSION:TIME-SOURCE = "ala-bala".

DISPLAY "Unknowns:           " d1 dt1 SKIP WITH SIDE-LABELS NO-BOX.

d2  = DATE(11, 16, 1977).
dt2 = DATETIME(11, 16, 1977, 14, 35, 59).
DISPLAY "Assinged by fields: " d2 dt2 SKIP.

d3  = DATE("16-11-1977").              /* assume DMY format */
dt3 = DATETIME("16-11-1977 14:35:59"). /* assume DMY format */
DISPLAY "Parsed from string: " d3 dt3 SKIP.

d4  = DATE(dt3).
dt4 = DATETIME(d3).
DISPLAY "Cross assigned:     " d4 dt4 SKIP.

d5  = DATE(2500000).
dt5 = DATETIME(d5, ((14 * 60 + 35) * 60 + 59) * 1000 + 0).
DISPLAY "Using ints:         " d5  FORMAT "99/99/9999" 
                               dt5 FORMAT "99/99/9999" SKIP.

d6  = ?.       /* = operator, assign to unknown */
dt6 = ?.       /* = operator, assign to unknown */
d6  = dt5.     /* = operator, assign date to datetime */
dt6 = d5.      /* = operator, assign datetime to date */
d6  = TODAY.   /* = operator, assign date to date, TODAY function  */
dt6 = NOW.     /* = operator, assign datetime to datetime, NOW function */

DISPLAY "STRING function:    " STRING(d6)    STRING(dt6)    SKIP.

DISPLAY "ISO-DATE function:  " ISO-DATE(d6)  FORMAT "x(10)"
                               ISO-DATE(dt6) FORMAT "x(23)" SKIP.
DISPLAY "DAY function:       " DAY(d6)       DAY(dt6)       SKIP.
DISPLAY "MONTH function:     " MONTH(d6)     MONTH(dt6)     SKIP.
DISPLAY "YEAR function:      " YEAR(d6)      YEAR(dt6)      SKIP.
DISPLAY "WEEKDAY function:   " WEEKDAY(d6)   WEEKDAY(dt6)   SKIP.
DISPLAY "MTIME function:     " MTIME(dt6)    MTIME()        SKIP.

DISPLAY "INTERVAL function:  " INTERVAL(d6, dt6, "seconds") SKIP.
DISPLAY "ADD-INTERVAL funct: " 
        ADD-INTERVAL(d6,  31, "days")
        ADD-INTERVAL(dt6, 48, "hours")
        SKIP.

DISPLAY "+ operator:         " d6 +  10     dt6 +  1000 * 60 * 60 * 24 * 3  SKIP.
DISPLAY "- operator 1:       " d6 -  10     dt6 -  1000 * 60 * 60 * 24 * 3  SKIP.
DISPLAY "- operator 2:       " d6 -  TODAY  dt6 -  NOW        SKIP.
DISPLAY "> & >= operator:    " d6 >  TODAY  dt6 >  NOW 
                               d6 >= TODAY  dt6 >= NOW        SKIP.
DISPLAY "< & <= operator:    " d6 <  TODAY  dt6 <  NOW
                               d6 <= TODAY  dt6 <= NOW        SKIP.
DISPLAY "= & <> operator:    " d6  = TODAY  dt6  = NOW
                               d6 <> TODAY  dt6 <> NOW        SKIP.

DISPLAY "DECIMAL INT INT64:  " DECIMAL(d6) FORMAT "->,>>>,>>9.99"
                               INTEGER(d6) INT64(d6).

/*
 * Expected output:
 *
 * Unknowns:            d1:          dt1:
 * Assinged by fields:  d2: 16/11/77 dt2: 16/11/1977 14:35:59.000
 * Parsed from string:  d3: 16/11/77 dt3: 16/11/1977 14:35:59.000
 * Cross assigned:      d4: 16/11/77 dt4: 16/11/1977 00:00:00.000
 * Using ints:          d5: 30/08/2132 dt5: 30/08/2132
 * STRING function:     14/01/13 14/01/20
 * ISO-DATE function:   2013-01-14 2013-01-14
 * DAY function:        14         14
 * MONTH function:      1          1
 * YEAR function:       2,013      2,013
 * WEEKDAY function:    2          2
 * MTIME function:      40,119,154
 * INTERVAL function:   0
 * ADD-INTERVAL funct:  24/01/13 15/01/2013 07:08:39.154
 * + operator:          24/01/13 14/01/2013 11:09:04.154
 * - operator 1:        04/01/13 14/01/2013 11:08:14.154
 * - operator 2:        0          -13
 * > & >= operator:     no  no  yes no
 * < & <= operator:     no  yes yes yes
 * = & <> operator:     yes no  no  yes
 * DECIMAL INT INT64:   2,456,308.00  2,456,308  2,456,308
 *
 */